bookings/urls.py
from django.urls import path, re_path
from django.views.generic import TemplateView

from bookings.views.bookings import (
    BookingDetailView,
    BookingUpdateView,
    BookingDeleteView,
    BookingCreateView,
)
from bookings.views.occurrences import (
    BookingOccurrenceCreateView,
    BookingOccurrenceUpdateView,
    BookingOccurrenceDeleteView,
)
from bookings.views.other import (
    ResourceCategoryDayView,
    CountableOccurrencesList,
    BookingFormView,
)
from bookings.views.api_va import api_va

app_name = "bookings"

urlpatterns = [
    path(
        "home/", TemplateView.as_view(template_name="bookings/home.html"), name="home"
    ),
    re_path(
        r"^resource-category/(?P<id>[0-9]+)$",
        ResourceCategoryDayView.as_view(),
        name="resource-category-day",
    ),
    re_path(r"^form/(?P<pk>[0-9]+)$", BookingFormView.as_view(), name="booking-form"),
    re_path(
        r"^booking/(?P<pk>[0-9]+)$", BookingDetailView.as_view(), name="booking-details"
    ),
    re_path(
        r"^booking/(?P<pk>[0-9]+)/edit$",
        BookingUpdateView.as_view(),
        name="booking-update",
    ),
    re_path(
        r"^booking/(?P<pk>[0-9]+)/delete$",
        BookingDeleteView.as_view(),
        name="booking-delete",
    ),
    path("booking/new", BookingCreateView.as_view(), name="booking-new"),
    re_path(
        r"^booking/(?P<booking_pk>[0-9]+)/occurrence/new$",
        BookingOccurrenceCreateView.as_view(),
        name="occurrence-new",
    ),
    re_path(
        r"^booking/(?P<booking_pk>[0-9]+)/occurrence/(?P<pk>[0-9]+)$",
        BookingOccurrenceUpdateView.as_view(),
        name="occurrence-edit",
    ),
    re_path(
        r"^booking/(?P<booking_pk>[0-9]+)/occurrence/(?P<pk>[0-9]+)/delete$",
        BookingOccurrenceDeleteView.as_view(),
        name="occurrence-delete",
    ),
    path("occurrences", CountableOccurrencesList.as_view(), name="occurrences_filter"),
    re_path(r"^api/va/(?P<va_key>c[0-9]+)$", api_va, name="api_va"),
    path("help", TemplateView.as_view(template_name="bookings/help.html"), name="help"),
]

resa/urls.py
from django.urls import path, include
from django.contrib import admin

urlpatterns = [
    path("admin/", admin.site.urls),
    path("", include("account.urls")),
    path("book/", include("bookings.urls", namespace="bookings")),
]

bookings/views/api_va.py
from django.contrib.auth.decorators import login_required
from django.http import JsonResponse

from bookings.adhesion import AdhesionAPI


@login_required
def api_va(request, va_key):
    api = AdhesionAPI()
    va_info = api.get_va(va_key)
    if va_info is None:
        return JsonResponse(dict(), status=404)
    va_info = {
        key: va_info[key] for key in ["first_name", "last_name", "email", "phone"]
    }
    return JsonResponse(va_info)

bookings/views/bookings.py
import datetime as dt
import logging

import dateutil.parser
from django.contrib import messages
from django.contrib.auth.decorators import login_required, permission_required
from django.core.paginator import Paginator, EmptyPage
from django.shortcuts import get_object_or_404, redirect
from django.urls import reverse, reverse_lazy
from django.utils.decorators import method_decorator
from django.utils.translation import gettext_lazy as _
from django.views.generic import CreateView, DeleteView, DetailView, UpdateView
from django.views.generic.base import ContextMixin

from bookings.forms import BookingFormForm
from bookings.models import ResourceCategory, Resource, Booking, BookingOccurrence

log = logging.getLogger(__name__)


class BaseBookingView(ContextMixin):
    booking = None

    def get_context_data(self, **kwargs):
        context = super(BaseBookingView, self).get_context_data(**kwargs)
        page = self.request.GET.get("occ_page", 1)

        occurrences = self.booking.get_occurrences().order_by("start")
        paginator = Paginator(occurrences, 10)

        try:
            occurrences = paginator.page(page)
        except EmptyPage:
            occurrences = paginator.page(paginator.num_pages)

        context["occurrences"] = occurrences
        return context


class BookingCreateView(CreateView):
    model = Booking
    fields = [
        "contact_first_name",
        "contact_last_name",
        "contact_email",
        "contact_phone",
        "contact_asso",
        "reason",
        "details",
    ]
    template_name = "bookings/booking/booking_new.html"
    decorators = [login_required, permission_required("bookings.add_booking")]
    start = None
    end = None
    booking = None
    object = None
    resource = None

    def get_form(self, form_class=None):
        form = super(BookingCreateView, self).get_form(form_class=form_class)
        booking_type = self.resource.category.booking_type
        if booking_type == ResourceCategory.ASSO:
            form.fields["contact_asso"].required = True
        elif booking_type == ResourceCategory.STUDENT:
            del form.fields["contact_asso"]
        return form

    def get_success_url(self):
        return (
            reverse("bookings:occurrence-new", kwargs={"booking_pk": self.booking.pk})
            + "?start="
            + str(self.start.isoformat())
            + "&end="
            + str(self.end.isoformat())
            + "&resource="
            + str(self.resource.id)
        )

    def dispatch(self, request, *args, **kwargs):
        self.resource = get_object_or_404(Resource, pk=self.request.GET.get("resource"))

        start = self.request.GET.get("start")
        end = self.request.GET.get("end")

        if start is not None:
            self.start = dateutil.parser.parse(start)
        else:
            self.start = dt.datetime.now()

        if end is not None:
            self.end = dateutil.parser.parse(end)
        else:
            self.end = self.start

        return super(BookingCreateView, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(BookingCreateView, self).get_context_data(**kwargs)
        context["start"] = self.start
        context["end"] = self.end
        context["resource_id"] = self.resource.id

        return context

    @method_decorator(decorators)
    def post(self, request, *args, **kwargs):
        form = self.get_form()

        if form.is_valid():
            self.booking = form.save()

            messages.success(request, _("Réservation créée avec succès"))
            return self.form_valid(form)
        else:
            return self.form_invalid(form)

    @method_decorator(decorators)
    def get(self, request, *args, **kwargs):
        return super(BookingCreateView, self).get(request, *args, **kwargs)


class BookingDetailView(DetailView, BaseBookingView):
    model = Booking
    template_name = "bookings/booking/booking_detail.html"
    booking = None

    def dispatch(self, request, *args, **kwargs):
        self.booking = get_object_or_404(Booking, pk=self.kwargs["pk"])
        return super(BookingDetailView, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(BookingDetailView, self).get_context_data(**kwargs)
        resource_requires_form = Resource.objects.filter(category__booking_form=True)

        form_needed = (
            BookingOccurrence.objects.filter(booking=self.booking)
            .filter(resources__in=resource_requires_form)
            .distinct()
            .exists()
        )

        if form_needed:
            context["booking_form"] = BookingFormForm(booking=self.booking)

        return context

    @method_decorator(login_required)
    def get(self, request, *args, **kwargs):
        return super(BookingDetailView, self).get(request, *args, **kwargs)

    @method_decorator(login_required)
    def post(self, request, *args, **kwargs):
        return redirect(to="bookings:booking-form", pk=request.POST.get("occurrence"))


class BookingUpdateView(UpdateView, BaseBookingView):
    model = Booking
    template_name = "bookings/booking/booking_edit.html"
    fields = [
        "contact_first_name",
        "contact_last_name",
        "contact_email",
        "contact_phone",
        "contact_asso",
        "reason",
        "details",
    ]
    decorators = [login_required, permission_required("bookings.change_booking")]
    booking = None

    def dispatch(self, request, *args, **kwargs):
        self.booking = get_object_or_404(Booking, pk=self.kwargs["pk"])
        return super(BookingUpdateView, self).dispatch(request, *args, **kwargs)

    @method_decorator(decorators)
    def get(self, request, *args, **kwargs):
        return super(BookingUpdateView, self).get(request, *args, **kwargs)

    @method_decorator(decorators)
    def post(self, request, *args, **kwargs):
        return super(BookingUpdateView, self).post(request, *args, **kwargs)


class BookingDeleteView(DeleteView, BaseBookingView):
    model = Booking
    decorators = [login_required, permission_required("bookings.delete_booking")]
    booking = None
    template_name = "bookings/booking/booking_delete.html"

    def dispatch(self, request, *args, **kwargs):
        self.booking = self.get_object()
        return super(BookingDeleteView, self).dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        context = super(BookingDeleteView, self).get_context_data(**kwargs)
        context["booking"] = self.booking

        return context

    def get_success_url(self):
        return reverse_lazy("bookings:home")

    @method_decorator(decorators)
    def get(self, request, *args, **kwargs):
        return super(BookingDeleteView, self).get(request, *args, **kwargs)

    @method_decorator(decorators)
    def delete(self, request, *args, **kwargs):
        return super(BookingDeleteView, self).delete(request, *args, **kwargs)

bookings/templates/bookings/occurrence/occurrence_delete.html
{% extends 'bookings/occurrence/occurrence_edit.html' %}
{% load crispy_forms_filters %}
{% load i18n %}

{% block title %}{% translate 'Supprimer une occurrence' %}{% endblock %}

{% block start_form %}
{% endblock start_form %}

{% block end_form %}
{% endblock end_form %}

{% block occurrence_card_body %}
    <div class="card-body">
        <form action="{% url 'bookings:occurrence-delete' booking_pk=booking.pk pk=bookingoccurrence.pk %}" method="post">
            {% csrf_token %}
            <p>{% translate "Êtes-vous certain de vouloir supprimer l'occurrence suivante ?" %}</p>
            <p>{{ bookingoccurrence }}</p>
            <button type="submit" class="btn btn-danger btn-block">
                <span class="fa-solid fa-trash-can"></span> {% translate 'Supprimer' %}
            </button>
        </form>
    </div>
{% endblock %}

bookings/templates/bookings/occurrence/occurrence_edit.html
{% extends 'bookings/booking/booking_detail.html' %}
{% load crispy_forms_filters %}
{% load i18n %}
{% load static %}

{% block javascript %}
    {{ block.super }}
    <script defer src="{% static 'bookings/occurrence_edit.js' %}"></script>
{% endblock javascript %}

{% block title %}{% translate "Édition de l'occurrence" %}{% endblock %}

{% block start_form %}
    <form action="{% url 'bookings:occurrence-edit' booking_pk=booking.pk pk=object.pk %}" method="post">
{% endblock start_form %}

{% block occurrence_form %}
    <div class="card-header">
        <div class="btn-group pull-end">
            <a href="{% url 'bookings:booking-details' pk=booking.pk %}"
               class="btn btn-sm btn-warning">
                <span class="fa-solid fa-xmark"></span> {% translate 'Annuler' %}
            </a>
            <button type="submit" class="btn btn-sm btn-success">
                <span class="fa-solid fa-floppy-disk"></span> {% translate 'Enregistrer' %}
            </button>
        </div>
        <h3 class="card-title"><span class="fa-solid fa-calendar"></span> {% translate 'Occurrences' %}
        </h3>
    </div>
    {% block occurrence_card_body %}
        <div class="card-body">
            {{ form.media }}
            {% csrf_token %}
            {{ form|crispy }}
            <div class="btn-group pull-end">
                <button type="submit" class="btn btn-success">
                    <span class="fa-solid fa-floppy-disk"></span> {% translate 'Enregistrer' %}
                </button>
                {% if perms.bookings.delete_bookingoccurrence %}
                    <a href="{% url 'bookings:occurrence-delete' booking_pk=booking.pk pk=object.pk %}" class="btn btn-danger">
                        <span class="fa-solid fa-trash-can"></span> Supprimer
                    </a>
                {% endif %}
            </div>
        </div>
    {% endblock %}
{% endblock %}

bookings/templates/bookings/occurrence/occurrence_new.html
{% extends 'bookings/occurrence/occurrence_edit.html' %}
{% load crispy_forms_filters %}
{% load i18n %}

{% block title %}{% translate 'Nouvelle occurrence' %}{% endblock %}

{% block start_form %}
    <form action="{% url 'bookings:occurrence-new' booking_pk=booking.pk %}{% if initial_resource %}?resource={{ initial_resource.pk }}{% endif %}" method="post">
{% endblock start_form %}

{% block occurrence_card_body %}
    <div class="card-body">
        {{ form.media }}
        {% csrf_token %}
        {{ form|crispy }}
    </div>
    <div class="card-footer">
        <button type="submit" class="btn btn-success btn-block">
            <span class="fa-solid fa-floppy-disk"></span> {% translate 'Enregistrer' %}
        </button>
    </div>
{% endblock %}

{% block end_form %}
    </form>
{% endblock end_form %}

bookings/templates/bookings/occurrence/occurrences_filter_list.html
{% extends 'base.html' %}
{% load i18n %}

{% block add-content %}
    <h2>
        {% block title %}
            {% translate 'Résultats' %}
        {% endblock title %}
    </h2>
    <div class="row">
        <div class="col-md-6">
            <div class="card card-light">
                <div class="card-header">
                    <h3 class="card-title">
                        {% blocktranslate count counter=occurrences_list|length %}
                            {{ counter }} ressource réservée
                        {% plural %}
                            {{ counter }} ressource(s) réservée(s)
                        {% endblocktranslate %}
                    </h3>
                </div>
                <div class="list-group">
                    {% for occurrence in occurrences_list %}
                        <a class="list-group-item"
                           href="{% url 'bookings:booking-details' pk=occurrence.booking.pk %}">{{ occurrence }}</a>
                    {% endfor %}
                </div>
            </div>
        </div>
    </div>
{% endblock add-content %}